package com.glxp.sale.admin.controller.info;

import com.github.pagehelper.PageInfo;
import com.glxp.sale.admin.entity.auth.AuthAdmin;
import com.glxp.sale.admin.entity.auth.CustomerContactEntity;
import com.glxp.sale.admin.entity.info.CompanyEntity;
import com.glxp.sale.admin.entity.info.CompanyUpdateLogEntity;
import com.glxp.sale.admin.exception.JsonException;
import com.glxp.sale.admin.req.info.CompanyRequest;
import com.glxp.sale.admin.req.info.FilterCompanyRequest;
import com.glxp.sale.admin.res.PageSimpleResponse;
import com.glxp.sale.admin.service.auth.AuthAdminService;
import com.glxp.sale.admin.service.auth.impl.CustomerContactService;
import com.glxp.sale.admin.service.info.CompanyService;
import com.glxp.sale.admin.service.info.CompanyUpdateLogService;
import com.glxp.sale.common.enums.ResultEnum;
import com.glxp.sale.common.res.BaseResponse;
import com.glxp.sale.common.util.ResultVOUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.File;
import java.util.Date;
import java.util.List;

@RestController
public class CompanyController {
    @Resource
    private AuthAdminService authAdminService;
    @Resource
    private CompanyService companyService;
    @Resource
    CustomerContactService customerContactService;
    @Resource
    private CompanyUpdateLogService companyUpdateLogService;

    @GetMapping("/warehouse/info/company")
    public BaseResponse getCompanyInfo(CompanyRequest companyRequest) {
        CompanyEntity companyEntity = companyService.findCompany(companyRequest.getCustomerId());
        if (companyEntity != null) {
            return ResultVOUtils.success(companyEntity);
        }
        return ResultVOUtils.error(500, "企业信息为空");
    }

    @GetMapping("/sale/info/getSubCompany")
    public BaseResponse getSubCompany(FilterCompanyRequest companyRequest) {
//        companyRequest.setCustomerId(getCustomerId());
        List<CompanyEntity> companyEntities = companyService.getSubCompany(companyRequest);
        PageInfo<CompanyEntity> pageInfo = new PageInfo<>(companyEntities);
        PageSimpleResponse<CompanyEntity> pageSimpleResponse = new PageSimpleResponse<>();
        pageSimpleResponse.setTotal(pageInfo.getTotal());
        pageSimpleResponse.setList(companyEntities);
        return ResultVOUtils.success(pageSimpleResponse);
    }

    @GetMapping("/sale/info/getSubCompany2")
    public BaseResponse getSubCompany2(FilterCompanyRequest companyRequest) {
        List<CompanyEntity> companyEntities = companyService.getSubCompany2(companyRequest);
        PageInfo<CompanyEntity> pageInfo = new PageInfo<>(companyEntities);
        PageSimpleResponse<CompanyEntity> pageSimpleResponse = new PageSimpleResponse<>();
        pageSimpleResponse.setTotal(pageInfo.getTotal());
        pageSimpleResponse.setList(companyEntities);
        return ResultVOUtils.success(pageSimpleResponse);
    }

    @PostMapping("/warehouse/info/modifyCompany")
    public BaseResponse modifyCompany(@RequestBody CompanyEntity companyEntity) {
//        if (companyEntity.getParentCompany() != null && !companyEntity.getParentCompany().equals("")) {
//            CompanyEntity parent = companyService.findCompanyByName(companyEntity.getParentCompany());
//            if (parent == null) {
//                return ResultVOUtils.error(500, "所属连锁总部未注册，请注册后重试！");
//            }
//            companyEntity.setParentIdFk(parent.getCustomerId() + "");
//        }
        if (StringUtils.isNotBlank(companyEntity.getNewFilePath())) {
            if (StringUtils.isNotBlank(companyEntity.getFilePath())) {
                String URL="d:/1s/udiwms/register/file/image1/" + companyEntity.getFilePath();
                File file=new File(URL);
                if(file.exists()&&file.isFile()) {
                    file.delete();
                }
            }
            companyEntity.setFilePath(companyEntity.getNewFilePath());
        }
        if (StringUtils.isNotBlank(companyEntity.getNewFilePath2())) {
            if (StringUtils.isNotBlank(companyEntity.getFilePath2())) {
                String URL="d:/1s/udiwms/register/file/image1/" + companyEntity.getFilePath2();
                File file=new File(URL);
                if(file.exists()&&file.isFile()) {
                    file.delete();
                }
            }
            companyEntity.setFilePath2(companyEntity.getNewFilePath2());
        }
        if (StringUtils.isNotBlank(companyEntity.getNewFilePath3())) {
            if (StringUtils.isNotBlank(companyEntity.getFilePath3())) {
                String URL="d:/1s/udiwms/register/file/image1/" + companyEntity.getFilePath3();
                File file=new File(URL);
                if(file.exists()&&file.isFile()) {
                    file.delete();
                }
            }
            companyEntity.setFilePath3(companyEntity.getNewFilePath3());
        }
        if (StringUtils.isNotBlank(companyEntity.getNewFilePath4())) {
            if (StringUtils.isNotBlank(companyEntity.getFilePath4())) {
                String URL="d:/1s/udiwms/register/file/image1/" + companyEntity.getFilePath4();
                File file=new File(URL);
                if(file.exists()&&file.isFile()) {
                    file.delete();
                }
            }
            companyEntity.setFilePath4(companyEntity.getNewFilePath4());
        }
        if (StringUtils.isNotBlank(companyEntity.getNewAuditStatus())) {//0：草稿，6：未审核
            companyEntity.setAuditStatus(companyEntity.getNewAuditStatus());
        }
        if (StringUtils.isNotBlank(companyEntity.getAuditStatus()) &&
                (companyEntity.getAuditStatus().equals("1") || companyEntity.getAuditStatus().equals("2"))) {
            CompanyUpdateLogEntity companyUpdateLogEntity = new CompanyUpdateLogEntity();
            companyUpdateLogEntity.setCustomerId(companyEntity.getCustomerId());
            companyUpdateLogEntity.setCreate_time(new Date());
            companyUpdateLogEntity.setUpdate_time(new Date());
            companyUpdateLogEntity.setSubmit(companyEntity.getCompanyName());
            companyUpdateLogEntity.setAuditor(companyEntity.getAuditor());
            companyUpdateLogEntity.setLogType("1");//新增审核
            companyUpdateLogEntity.setUpdateCause("新增审核");
            companyUpdateLogEntity.setNoPassCause(companyEntity.getNoPassCause());
            if (companyEntity.getAuditStatus().equals("1")) {
                companyUpdateLogEntity.setStatus("2");
            } else {
                companyUpdateLogEntity.setStatus("3");
            }
            companyUpdateLogService.insertCompanyUpdateLog(companyUpdateLogEntity);
        }
        boolean b = companyService.modifyCompany(companyEntity);
        CustomerContactEntity customerContactEntity = new CustomerContactEntity();
        customerContactEntity.setTel(companyEntity.getTel());
        customerContactEntity.setMobile(companyEntity.getMobile());
        customerContactEntity.setEmail(companyEntity.getEmail());
        customerContactEntity.setContacts(companyEntity.getContacts());
        customerContactEntity.setCustomerId(companyEntity.getCustomerId());

        try {
            customerContactService.updateCustomerContact(customerContactEntity);
        } catch (Exception e) {

        }
        return ResultVOUtils.success("修改成功");
    }

    public String getCustomerId() {
        ServletRequestAttributes attributes = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
        if (attributes == null) {
            throw new JsonException(ResultEnum.NOT_NETWORK);
        }
        HttpServletRequest request = attributes.getRequest();
        String userId = request.getHeader("ADMIN_ID");
        AuthAdmin authAdmin = authAdminService.findById(Long.parseLong(userId));
        return authAdmin.getCustomerId() + "";
    }
}
