package com.glxp.sale.admin.controller.info;

import com.glxp.sale.admin.entity.info.SetupEntity;
import com.glxp.sale.admin.req.info.CompanyRequest;
import com.glxp.sale.admin.service.info.SetupService;
import com.glxp.sale.common.res.BaseResponse;
import com.glxp.sale.common.util.ResultVOUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@RestController
public class SetupController {

    @Resource
    private SetupService setupService;

    @GetMapping("/sale/info/setup")
    public BaseResponse getCompanyInfo(CompanyRequest companyRequest) {
        SetupEntity setupEntity = setupService.findSetup(companyRequest.getCustomerId()+"");
        if (setupEntity != null) {
            return ResultVOUtils.success(setupEntity);
        }
        return ResultVOUtils.error(500, "设置信息为空");
    }

    @PostMapping("/sale/info/setup/modify")
    public BaseResponse modifyCompany(@RequestBody SetupEntity setupEntity) {
        setupService.insertSetup(setupEntity);
        return ResultVOUtils.success("修改成功");
    }

}
