package com.glxp.sale.admin.httpclient;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.glxp.sale.admin.req.basic.BasicUnitMaintainFilterRequest;
import com.glxp.sale.admin.req.basic.FilterErpGoodsRequest;
import com.glxp.sale.admin.res.PageSimpleResponse;
import com.glxp.sale.admin.res.basic.ErpProductsResponse;
import com.glxp.sale.admin.res.basic.ErpUnitsResponse;
import com.glxp.sale.admin.util.HttpClient;
import com.glxp.sale.common.res.BaseResponse;
import com.glxp.sale.common.util.ResultVOUtils;

import java.util.HashMap;
import java.util.Map;

/**
 * 获取ERP基础数据
 */
public class ErpBasicClient {


    //获取往来单位
    public BaseResponse<PageSimpleResponse<ErpUnitsResponse>> getErpCrop(BasicUnitMaintainFilterRequest unitMaintainFilterRequest, String url) {
        Map<String, Object> paramMap = new HashMap<>(16);
        paramMap.put("name", unitMaintainFilterRequest.getName());
        paramMap.put("unitId", unitMaintainFilterRequest.getUnitId());
        paramMap.put("key", unitMaintainFilterRequest.getKey());
        paramMap.put("page", unitMaintainFilterRequest.getPage());
        paramMap.put("limit", unitMaintainFilterRequest.getLimit());
        String response = HttpClient.mipsGet(url, paramMap);
        try {
            BaseResponse<PageSimpleResponse<ErpUnitsResponse>> udiDlDeviceResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse<PageSimpleResponse<ErpUnitsResponse>>>() {
                    });
            return udiDlDeviceResponse;
        } catch (Exception e) {
            e.printStackTrace();
            return ResultVOUtils.error(500, "连接ERP服务出错！");
        }
    }

    //获取产品信息
    public BaseResponse<PageSimpleResponse<ErpProductsResponse>> getErpProducts(FilterErpGoodsRequest filterErpGoodsRequest, String url) {
        Map<String, Object> paramMap = new HashMap<>(16);
        paramMap.put("code", filterErpGoodsRequest.getCode());
        paramMap.put("name", filterErpGoodsRequest.getName());
        paramMap.put("limit", filterErpGoodsRequest.getLimit());
        paramMap.put("page", filterErpGoodsRequest.getPage());

        String response = HttpClient.mipsGet(url, paramMap);
        try {
            BaseResponse<PageSimpleResponse<ErpProductsResponse>> udiDlDeviceResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse<PageSimpleResponse<ErpProductsResponse>>>() {
                    });
            return udiDlDeviceResponse;
        } catch (Exception e) {
            e.printStackTrace();
            return ResultVOUtils.error(500, "连接ERP服务出错！");
        }
    }


}
