package com.glxp.sale.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.basic.BasicThirdSysDao;
import com.glxp.sale.admin.entity.basic.BasicThirdSysEntity;
import com.glxp.sale.admin.entity.param.SystemParamConfigEntity;
import com.glxp.sale.admin.req.basic.FilterBasicThirdSysRequest;
import com.glxp.sale.admin.service.basic.BasicThirdSysService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class BasicThirdSysServiceImpl implements BasicThirdSysService {

    @Override
    public boolean insert(BasicThirdSysEntity basicThirdSysEntity) {
        return basicThirdSysDao.insert(basicThirdSysEntity);
    }

    @Resource
    BasicThirdSysDao basicThirdSysDao;

    @Override
    public boolean updateBasicThiSys(BasicThirdSysEntity basicThirdSysEntity) {
        return basicThirdSysDao.updateBasicThiSys(basicThirdSysEntity);
    }

    @Override
    public BasicThirdSysEntity selectByThirdId(String thirdId) {
        return basicThirdSysDao.selectByThirdId(thirdId);
    }

    @Override
    public List<BasicThirdSysEntity> filterBasicThiSys(FilterBasicThirdSysRequest filterBasicThirdSysRequest) {
        if (filterBasicThirdSysRequest == null) {
            return Collections.emptyList();
        }

        if (filterBasicThirdSysRequest.getPage() != null) {
            int offset = (filterBasicThirdSysRequest.getPage() - 1) * filterBasicThirdSysRequest.getLimit();
            PageHelper.offsetPage(offset, filterBasicThirdSysRequest.getLimit());
        }
        List<BasicThirdSysEntity> data = basicThirdSysDao.filterBasicThiSys(filterBasicThirdSysRequest);
        return data;
    }

    @Override
    public BasicThirdSysEntity selectMainThrSys() {
        FilterBasicThirdSysRequest filterBasicThirdSysRequest = new FilterBasicThirdSysRequest();
        filterBasicThirdSysRequest.setMainSys(true);
        List<BasicThirdSysEntity> data = basicThirdSysDao.filterBasicThiSys(filterBasicThirdSysRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }
}
