package com.glxp.sale.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.basic.BussinessTypeDao;
import com.glxp.sale.admin.entity.basic.BasicThirdSysDetailEntity;
import com.glxp.sale.admin.entity.basic.BussinessTypeEntity;
import com.glxp.sale.admin.req.basic.BussinessTypeFilterRequest;
import com.glxp.sale.admin.res.basic.BussinessTypResponse;
import com.glxp.sale.admin.service.basic.BasicThirdSysDetailService;
import com.glxp.sale.admin.service.basic.BussinessTypeService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class BussinessTypeServiceImpl implements BussinessTypeService {

    @Resource
    BussinessTypeDao bussinessTypeDao;
    @Resource
    BasicThirdSysDetailService basicThirdSysDetailService;

    @Override
    public List<BussinessTypeEntity> filterList(BussinessTypeFilterRequest bussinessTypeFilterRequest) {
        if (bussinessTypeFilterRequest == null) {
            return Collections.emptyList();
        }
        if (bussinessTypeFilterRequest.getPage() != null) {
            int offset = (bussinessTypeFilterRequest.getPage() - 1) * bussinessTypeFilterRequest.getLimit();
            PageHelper.offsetPage(offset, bussinessTypeFilterRequest.getLimit());
        }
        List<BussinessTypeEntity> data = bussinessTypeDao.filterList(bussinessTypeFilterRequest);
        return data;
    }

    @Override
    public List<BussinessTypResponse> filterJoinList(BussinessTypeFilterRequest bussinessTypeFilterRequest) {
        if (bussinessTypeFilterRequest == null) {
            return Collections.emptyList();
        }
        if (bussinessTypeFilterRequest.getPage() != null) {
            int offset = (bussinessTypeFilterRequest.getPage() - 1) * bussinessTypeFilterRequest.getLimit();
            PageHelper.offsetPage(offset, bussinessTypeFilterRequest.getLimit());
        }
        List<BussinessTypResponse> data = bussinessTypeDao.filterJoinList(bussinessTypeFilterRequest);
        return data;
    }

    @Override
    public BussinessTypeEntity findBTByAction(String action) {
        BussinessTypeFilterRequest bussinessTypeFilterRequest = new BussinessTypeFilterRequest();
        bussinessTypeFilterRequest.setAction(action);
        List<BussinessTypeEntity> data = bussinessTypeDao.filterList(bussinessTypeFilterRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public BussinessTypeEntity findBTByName(String action) {
        BussinessTypeFilterRequest bussinessTypeFilterRequest = new BussinessTypeFilterRequest();
        bussinessTypeFilterRequest.setName(action);
        List<BussinessTypeEntity> data = bussinessTypeDao.filterList(bussinessTypeFilterRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public BussinessTypResponse findJoinBTByAction(String action) {
        BussinessTypeFilterRequest bussinessTypeFilterRequest = new BussinessTypeFilterRequest();
        bussinessTypeFilterRequest.setAction(action);
        bussinessTypeFilterRequest.setEnabled(true);
        List<BussinessTypResponse> data = bussinessTypeDao.filterJoinList(bussinessTypeFilterRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public BasicThirdSysDetailEntity findByActionKey(String action, String key) {
        BussinessTypResponse bussinessTypResponse = findJoinBTByAction(action);
        if (bussinessTypResponse != null) {
            BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailService.selectByKey(key, bussinessTypResponse.getThirdSysFk());
            return basicThirdSysDetailEntity;
        }
        return null;
    }

    @Override
    public boolean insertBussinessType(BussinessTypeEntity bussinessTypeEntity) {
        return bussinessTypeDao.insertBussinessType(bussinessTypeEntity);
    }

    @Override
    public boolean updateBussinessType(BussinessTypeEntity bussinessTypeEntity) {
        return bussinessTypeDao.updateBussinessType(bussinessTypeEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return bussinessTypeDao.deleteById(id);
    }
}
