package com.glxp.sale.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.info.CompanyCertDao;
import com.glxp.sale.admin.entity.info.AliKeyEntity;
import com.glxp.sale.admin.entity.info.CompanyCertEntity;
import com.glxp.sale.admin.entity.inout.StockOrderDetailEntity;
import com.glxp.sale.admin.req.info.FilterCompanyCertRequest;
import com.glxp.sale.admin.req.info.FilterCompanyRequest;
import com.glxp.sale.admin.req.inout.StockOrderDetailFilterRequest;
import com.glxp.sale.admin.service.info.CompanyCertService;
import com.glxp.sale.admin.service.info.CompanyService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CompanyCertServiceImpl implements CompanyCertService {

    @Resource
    CompanyCertDao companyCertDao;

    @Override
    public List<CompanyCertEntity> filterCompanyCert(FilterCompanyCertRequest filterCompanyCertRequest) {
        if (filterCompanyCertRequest == null) {
            return Collections.emptyList();
        }
        if (filterCompanyCertRequest.getPage() != null) {
            int offset = (filterCompanyCertRequest.getPage() - 1) * filterCompanyCertRequest.getLimit();
            PageHelper.offsetPage(offset, filterCompanyCertRequest.getLimit());
        }
        return companyCertDao.filterCompanyCert(filterCompanyCertRequest);
    }

    @Override
    public CompanyCertEntity findCompanyCert(Long CustomerId) {
        return companyCertDao.findCompanyCert(CustomerId);
    }

    @Override
    public List<CompanyCertEntity> getCompanyCert(FilterCompanyCertRequest filterCompanyCertRequest) {
        if (filterCompanyCertRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterCompanyCertRequest.getPage() - 1) * filterCompanyCertRequest.getLimit();
        PageHelper.offsetPage(offset, filterCompanyCertRequest.getLimit());
        List<CompanyCertEntity> companyEntities = companyCertDao.getCompanyCert(filterCompanyCertRequest);
        return companyEntities;
    }

    @Override
    public CompanyCertEntity findCompanyCertByName(String companyName) {
        return companyCertDao.findCompanyCertByName(companyName);
    }

    @Override
    public boolean updateCompanyCert(CompanyCertEntity companyCertEntity) {
        return companyCertDao.updateCompanyCert(companyCertEntity);
    }

    @Override
    public boolean insertCompanyCert(CompanyCertEntity companyCertEntity) {
        return companyCertDao.insertCompanyCert(companyCertEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return companyCertDao.deleteById(id);
    }
}
