package com.glxp.sale.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.info.CompanyProductRelevanceDao;
import com.glxp.sale.admin.entity.info.CompanyProductRelevanceEntity;
import com.glxp.sale.admin.req.basic.CompanyProductRelevanceRequest;
import com.glxp.sale.admin.req.info.FilterCompanyProductRelevanceRequest;
import com.glxp.sale.admin.res.basic.CompanyProductRelevanceResponse;
import com.glxp.sale.admin.service.info.CompanyProductRelevanceService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CompanyProductRelevanceServiceImpl implements CompanyProductRelevanceService {

    @Resource
    CompanyProductRelevanceDao companyProductRelevanceDao;

    @Override
    public List<CompanyProductRelevanceResponse> filterUdiGp(CompanyProductRelevanceRequest basicInstrumentMaintainRequest) {
        if (basicInstrumentMaintainRequest == null) {
            return Collections.emptyList();
        }
        if (basicInstrumentMaintainRequest.getPage() != null) {
            int offset = (basicInstrumentMaintainRequest.getPage() - 1) * basicInstrumentMaintainRequest.getLimit();
            PageHelper.offsetPage(offset, basicInstrumentMaintainRequest.getLimit());
        }

        List<CompanyProductRelevanceResponse> data = companyProductRelevanceDao.filterUdiGp(basicInstrumentMaintainRequest);
        return data;
    }

    @Override
    public List<CompanyProductRelevanceEntity> filterCompanyProductRelevance(FilterCompanyProductRelevanceRequest filterCompanyProductRelevanceRequest) {
        if (filterCompanyProductRelevanceRequest == null) {
            return Collections.emptyList();
        }
        if (filterCompanyProductRelevanceRequest.getPage() != null) {
            int offset = (filterCompanyProductRelevanceRequest.getPage() - 1) * filterCompanyProductRelevanceRequest.getLimit();
            PageHelper.offsetPage(offset, filterCompanyProductRelevanceRequest.getLimit());
        }
        return companyProductRelevanceDao.filterCompanyProductRelevance(filterCompanyProductRelevanceRequest);
    }

    @Override
    public CompanyProductRelevanceEntity findCompanyProductRelevance(Long CustomerId) {
        return companyProductRelevanceDao.findCompanyProductRelevance(CustomerId);
    }

    @Override
    public List<CompanyProductRelevanceEntity> getCompanyProductRelevance(FilterCompanyProductRelevanceRequest filterCompanyProductRelevanceRequest) {
        if (filterCompanyProductRelevanceRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterCompanyProductRelevanceRequest.getPage() - 1) * filterCompanyProductRelevanceRequest.getLimit();
        PageHelper.offsetPage(offset, filterCompanyProductRelevanceRequest.getLimit());
        List<CompanyProductRelevanceEntity> companyEntities = companyProductRelevanceDao.getCompanyProductRelevance(filterCompanyProductRelevanceRequest);
        return companyEntities;
    }

    @Override
    public CompanyProductRelevanceEntity findCompanyProductRelevanceByProductId(String productId) {
        return companyProductRelevanceDao.findCompanyProductRelevanceByProductId(productId);
    }

    @Override
    public CompanyProductRelevanceEntity findCompanyProductRelevanceByUdiRlIdFk(String udiRlIdFk,String customerId) {
        return companyProductRelevanceDao.findCompanyProductRelevanceByUdiRlIdFk(udiRlIdFk,customerId);
    }

    @Override
    public CompanyProductRelevanceEntity findCompanyProductRelevanceByProductUuid(CompanyProductRelevanceEntity companyProductRelevanceEntity) {
        return companyProductRelevanceDao.findCompanyProductRelevanceByProductUuid(companyProductRelevanceEntity);
    }

    @Override
    public boolean updateCompanyProductRelevance(CompanyProductRelevanceEntity companyProductRelevanceEntity) {
        return companyProductRelevanceDao.updateCompanyProductRelevance(companyProductRelevanceEntity);
    }

    @Override
    public boolean insertCompanyProductRelevance(CompanyProductRelevanceEntity companyProductRelevanceEntity) {
        return companyProductRelevanceDao.insertCompanyProductRelevance(companyProductRelevanceEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return companyProductRelevanceDao.deleteById(id);
    }
}
