package com.glxp.sale.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.info.CompanySalesmanDao;
import com.glxp.sale.admin.entity.info.CompanySalesmanEntity;
import com.glxp.sale.admin.req.info.FilterCompanySalesmanRequest;
import com.glxp.sale.admin.service.info.CompanySalesmanService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CompanySalesmanServiceImpl implements CompanySalesmanService {

    @Resource
    CompanySalesmanDao companySalesmanDao;

    @Override
    public List<CompanySalesmanEntity> filterCompanySalesman(FilterCompanySalesmanRequest filterCompanySalesmanRequest) {
        if (filterCompanySalesmanRequest == null) {
            return Collections.emptyList();
        }
        if (filterCompanySalesmanRequest.getPage() != null) {
            int offset = (filterCompanySalesmanRequest.getPage() - 1) * filterCompanySalesmanRequest.getLimit();
            PageHelper.offsetPage(offset, filterCompanySalesmanRequest.getLimit());
        }
        return companySalesmanDao.filterCompanySalesman(filterCompanySalesmanRequest);
    }

    @Override
    public CompanySalesmanEntity findCompanySalesman(Long CustomerId) {
        return companySalesmanDao.findCompanySalesman(CustomerId);
    }

    @Override
    public List<CompanySalesmanEntity> getCompanySalesman(FilterCompanySalesmanRequest filterCompanySalesmanRequest) {
        if (filterCompanySalesmanRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterCompanySalesmanRequest.getPage() - 1) * filterCompanySalesmanRequest.getLimit();
        PageHelper.offsetPage(offset, filterCompanySalesmanRequest.getLimit());
        List<CompanySalesmanEntity> companyEntities = companySalesmanDao.getCompanySalesman(filterCompanySalesmanRequest);
        return companyEntities;
    }

    @Override
    public CompanySalesmanEntity findCompanySalesmanByName(String companyName) {
        return companySalesmanDao.findCompanySalesmanByName(companyName);
    }

    @Override
    public boolean updateCompanySalesman(CompanySalesmanEntity companySalesmanEntity) {
        return companySalesmanDao.updateCompanySalesman(companySalesmanEntity);
    }

    @Override
    public boolean insertCompanySalesman(CompanySalesmanEntity companySalesmanEntity) {
        return companySalesmanDao.insertCompanySalesman(companySalesmanEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return companySalesmanDao.deleteById(id);
    }
}
