package com.glxp.sale.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.info.CompanySalesmanUpdateLogDao;
import com.glxp.sale.admin.entity.info.CompanySalesmanUpdateLogEntity;
import com.glxp.sale.admin.req.info.FilterCompanySalesmanUpdateLogRequest;
import com.glxp.sale.admin.service.info.CompanySalesmanUpdateLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CompanySalesmanUpdateLogServiceImpl implements CompanySalesmanUpdateLogService {

    @Resource
    CompanySalesmanUpdateLogDao companySalesmanUpdateLogDao;

    @Override
    public List<CompanySalesmanUpdateLogEntity> filterCompanySalesmanUpdateLog(FilterCompanySalesmanUpdateLogRequest filterCompanySalesmanUpdateLogRequest) {
        if (filterCompanySalesmanUpdateLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterCompanySalesmanUpdateLogRequest.getPage() != null) {
            int offset = (filterCompanySalesmanUpdateLogRequest.getPage() - 1) * filterCompanySalesmanUpdateLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterCompanySalesmanUpdateLogRequest.getLimit());
        }
        return companySalesmanUpdateLogDao.filterCompanySalesmanUpdateLog(filterCompanySalesmanUpdateLogRequest);
    }

    @Override
    public CompanySalesmanUpdateLogEntity findCompanySalesmanUpdateLog(Long CustomerId) {
        return companySalesmanUpdateLogDao.findCompanySalesmanUpdateLog(CustomerId);
    }

    @Override
    public List<CompanySalesmanUpdateLogEntity> getCompanySalesmanUpdateLog(FilterCompanySalesmanUpdateLogRequest filterCompanySalesmanUpdateLogRequest) {
        if (filterCompanySalesmanUpdateLogRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterCompanySalesmanUpdateLogRequest.getPage() - 1) * filterCompanySalesmanUpdateLogRequest.getLimit();
        PageHelper.offsetPage(offset, filterCompanySalesmanUpdateLogRequest.getLimit());
        List<CompanySalesmanUpdateLogEntity> companyEntities = companySalesmanUpdateLogDao.getCompanySalesmanUpdateLog(filterCompanySalesmanUpdateLogRequest);
        return companyEntities;
    }

    @Override
    public CompanySalesmanUpdateLogEntity findCompanySalesmanUpdateLogBySubmit(String submit) {
        return companySalesmanUpdateLogDao.findCompanySalesmanUpdateLogBySubmit(submit);
    }

    @Override
    public boolean updateCompanySalesmanUpdateLog(CompanySalesmanUpdateLogEntity companySalesmanUpdateLogEntity) {
        return companySalesmanUpdateLogDao.updateCompanySalesmanUpdateLog(companySalesmanUpdateLogEntity);
    }

    @Override
    public boolean insertCompanySalesmanUpdateLog(CompanySalesmanUpdateLogEntity companySalesmanUpdateLogEntity) {
        return companySalesmanUpdateLogDao.insertCompanySalesmanUpdateLog(companySalesmanUpdateLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return companySalesmanUpdateLogDao.deleteById(id);
    }
}
