package com.glxp.sale.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.info.CompanyDao;
import com.glxp.sale.admin.entity.info.AliKeyEntity;
import com.glxp.sale.admin.entity.info.CompanyEntity;
import com.glxp.sale.admin.req.info.FilterCompanyRequest;
import com.glxp.sale.admin.service.info.CompanyService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CompanyServiceImpl implements CompanyService {

    @Resource
    CompanyDao companyDao;

    @Override
    public CompanyEntity findCompany(Long CustomerId) {
        return companyDao.findCompany(CustomerId);
    }

    @Override
    public List<CompanyEntity> getSubCompany(FilterCompanyRequest commitRequest) {
        if (commitRequest == null) {
            return Collections.emptyList();
        }
        int offset = (commitRequest.getPage() - 1) * commitRequest.getLimit();
        PageHelper.offsetPage(offset, commitRequest.getLimit());
        List<CompanyEntity> companyEntities = companyDao.getSubCompany(commitRequest);
        return companyEntities;
    }

    @Override
    public List<CompanyEntity> getSubCompany2(FilterCompanyRequest commitRequest) {
        if (commitRequest == null) {
            return Collections.emptyList();
        }
        int offset = (commitRequest.getPage() - 1) * commitRequest.getLimit();
        PageHelper.offsetPage(offset, commitRequest.getLimit());
        List<CompanyEntity> companyEntities = companyDao.getSubCompany2(commitRequest);
        return companyEntities;
    }

    @Override
    public CompanyEntity findCompanyByName(String companyName) {
        return companyDao.findCompanyByName(companyName);
    }

    @Override
    public boolean modifyCompany(CompanyEntity companyEntity) {
        return companyDao.modifyCompany(companyEntity);
    }

    @Override
    public boolean insertCompany(CompanyEntity companyEntity) {
        return companyDao.insertCompany(companyEntity);
    }

    @Override
    public AliKeyEntity findKey(String customerId) {
        return companyDao.findKey(customerId);
    }
}
