package com.glxp.sale.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.info.CompanyUpdateLogDao;
import com.glxp.sale.admin.entity.info.CompanyUpdateLogEntity;
import com.glxp.sale.admin.req.info.FilterCompanyUpdateLogRequest;
import com.glxp.sale.admin.service.info.CompanyUpdateLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CompanyUpdateLogServiceImpl implements CompanyUpdateLogService {

    @Resource
    CompanyUpdateLogDao companyUpdateLogDao;

    @Override
    public List<CompanyUpdateLogEntity> filterCompanyUpdateLog(FilterCompanyUpdateLogRequest filterCompanyUpdateLogRequest) {
        if (filterCompanyUpdateLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterCompanyUpdateLogRequest.getPage() != null) {
            int offset = (filterCompanyUpdateLogRequest.getPage() - 1) * filterCompanyUpdateLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterCompanyUpdateLogRequest.getLimit());
        }
        return companyUpdateLogDao.filterCompanyUpdateLog(filterCompanyUpdateLogRequest);
    }

    @Override
    public CompanyUpdateLogEntity findCompanyUpdateLog(Long CustomerId) {
        return companyUpdateLogDao.findCompanyUpdateLog(CustomerId);
    }

    @Override
    public List<CompanyUpdateLogEntity> getCompanyUpdateLog(FilterCompanyUpdateLogRequest filterCompanyUpdateLogRequest) {
        if (filterCompanyUpdateLogRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterCompanyUpdateLogRequest.getPage() - 1) * filterCompanyUpdateLogRequest.getLimit();
        PageHelper.offsetPage(offset, filterCompanyUpdateLogRequest.getLimit());
        List<CompanyUpdateLogEntity> companyEntities = companyUpdateLogDao.getCompanyUpdateLog(filterCompanyUpdateLogRequest);
        return companyEntities;
    }

    @Override
    public CompanyUpdateLogEntity findCompanyUpdateLogBySubmit(String submit) {
        return companyUpdateLogDao.findCompanyUpdateLogBySubmit(submit);
    }

    @Override
    public boolean updateCompanyUpdateLog(CompanyUpdateLogEntity companyUpdateLogEntity) {
        return companyUpdateLogDao.updateCompanyUpdateLog(companyUpdateLogEntity);
    }

    @Override
    public boolean insertCompanyUpdateLog(CompanyUpdateLogEntity companyUpdateLogEntity) {
        return companyUpdateLogDao.insertCompanyUpdateLog(companyUpdateLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return companyUpdateLogDao.deleteById(id);
    }
}
