package com.glxp.sale.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.info.DeviceKeyDao;
import com.glxp.sale.admin.entity.info.DeviceKeyEntity;
import com.glxp.sale.admin.req.info.DeleteRequest;
import com.glxp.sale.admin.req.info.FilterDeviceKeyRequest;
import com.glxp.sale.admin.service.info.DeviceKeyService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class DeviceKeyServiceImpl implements DeviceKeyService {

    @Resource
    DeviceKeyDao deviceKeyDao;

    @Override
    public List<DeviceKeyEntity> findDeviceKey(FilterDeviceKeyRequest filterDeviceKeyRequest) {
        if (filterDeviceKeyRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterDeviceKeyRequest.getPage() - 1) * filterDeviceKeyRequest.getLimit();
        PageHelper.offsetPage(offset, filterDeviceKeyRequest.getLimit());
        return deviceKeyDao.findDeviceKey(filterDeviceKeyRequest);
    }

    @Override
    public DeviceKeyEntity findDeviceByImei(FilterDeviceKeyRequest filterDeviceKeyRequest) {
        return deviceKeyDao.findDeviceByImei(filterDeviceKeyRequest);
    }

    @Override
    public void insertDeviceKey(DeviceKeyEntity deviceKeyEntity) {
        deviceKeyDao.insertDeviceKey(deviceKeyEntity);
    }

    @Override
    public void updateDeviceKeyByImei(DeviceKeyEntity deviceKeyEntity) {
        deviceKeyDao.updateDeviceKeyByImei(deviceKeyEntity);
    }

    @Override
    public void updateDeviceKey(DeviceKeyEntity deviceKeyEntity) {
        deviceKeyDao.updateDeviceKey(deviceKeyEntity);
    }

    @Override
    public void deleteDeviceKey(DeleteRequest deleteRequest) {
        deviceKeyDao.deleteDeviceKey(deleteRequest);
    }
}
