package com.glxp.sale.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.info.SuppliersEnterpriseBasicDao;
import com.glxp.sale.admin.entity.info.SuppliersEnterpriseBasicEntity;
import com.glxp.sale.admin.req.info.SuppliersEnterpriseBasicRequest;
import com.glxp.sale.admin.service.info.SuppliersEnterpriseBasicService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class SuppliersEnterpriseBasicServiceImpl implements SuppliersEnterpriseBasicService {

    @Resource
    SuppliersEnterpriseBasicDao suppliersEnterpriseBasicDao;

    @Override
    public SuppliersEnterpriseBasicEntity findCompany(Long id) {
        return suppliersEnterpriseBasicDao.findCompany(id);
    }

    @Override
    public SuppliersEnterpriseBasicEntity findCompanyByName(String companyName) {
        return suppliersEnterpriseBasicDao.findCompanyByName(companyName);
    }

    @Override
    public List<SuppliersEnterpriseBasicEntity> getCompany(SuppliersEnterpriseBasicRequest suppliersEnterpriseBasicRequest) {
        if (suppliersEnterpriseBasicRequest == null) {
            return Collections.emptyList();
        }
        int offset = (suppliersEnterpriseBasicRequest.getPage() - 1) * suppliersEnterpriseBasicRequest.getLimit();
        PageHelper.offsetPage(offset, suppliersEnterpriseBasicRequest.getLimit());
        List<SuppliersEnterpriseBasicEntity> companyEntities = suppliersEnterpriseBasicDao.getCompany(suppliersEnterpriseBasicRequest);
        return companyEntities;
    }

    @Override
    public boolean modifyCompany(SuppliersEnterpriseBasicEntity companyEntity) {
        return suppliersEnterpriseBasicDao.modifyCompany(companyEntity);
    }

    @Override
    public boolean insertCompany(SuppliersEnterpriseBasicEntity companyEntity) {
        return suppliersEnterpriseBasicDao.insertCompany(companyEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return suppliersEnterpriseBasicDao.deleteById(id);
    }
}
