package com.glxp.sale.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.info.SuppliersEnterpriseBasicCertDao;
import com.glxp.sale.admin.entity.info.SupplierEnterpriseBasicCertEntity;
import com.glxp.sale.admin.req.info.FilterSuppliersEnterpriseBasicCertRequest;
import com.glxp.sale.admin.service.info.CompanyCertService;
import com.glxp.sale.admin.service.info.SuppliersEnterpriseBasicCertService;
import com.glxp.sale.admin.service.info.SuppliersEnterpriseBasicService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class SuppliersEnterpriseCertServiceImpl implements SuppliersEnterpriseBasicCertService {

    @Resource
    SuppliersEnterpriseBasicCertDao suppliersEnterpriseBasicCertDao;

    @Override
    public List<SupplierEnterpriseBasicCertEntity> filterCompanyCert(FilterSuppliersEnterpriseBasicCertRequest filterSuppliersEnterpriseBasicCertRequest) {
        if (filterSuppliersEnterpriseBasicCertRequest == null) {
            return Collections.emptyList();
        }
        if (filterSuppliersEnterpriseBasicCertRequest.getPage() != null) {
            int offset = (filterSuppliersEnterpriseBasicCertRequest.getPage() - 1) * filterSuppliersEnterpriseBasicCertRequest.getLimit();
            PageHelper.offsetPage(offset, filterSuppliersEnterpriseBasicCertRequest.getLimit());
        }
        return suppliersEnterpriseBasicCertDao.filterCompanyCert(filterSuppliersEnterpriseBasicCertRequest);
    }

    @Override
    public SupplierEnterpriseBasicCertEntity findCompanyCert(Long enterpriseId) {
        return suppliersEnterpriseBasicCertDao.findCompanyCert(enterpriseId);
    }

    @Override
    public List<SupplierEnterpriseBasicCertEntity> getCompanyCert(FilterSuppliersEnterpriseBasicCertRequest filterSuppliersEnterpriseBasicCertRequest) {
        if (filterSuppliersEnterpriseBasicCertRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterSuppliersEnterpriseBasicCertRequest.getPage() - 1) * filterSuppliersEnterpriseBasicCertRequest.getLimit();
        PageHelper.offsetPage(offset, filterSuppliersEnterpriseBasicCertRequest.getLimit());
        List<SupplierEnterpriseBasicCertEntity> companyEntities = suppliersEnterpriseBasicCertDao.getCompanyCert(filterSuppliersEnterpriseBasicCertRequest);
        return companyEntities;
    }

    @Override
    public SupplierEnterpriseBasicCertEntity findCompanyCertByName(String companyName) {
        return suppliersEnterpriseBasicCertDao.findCompanyCertByName(companyName);
    }

    @Override
    public boolean updateCompanyCert(SupplierEnterpriseBasicCertEntity supplierEnterpriseBasicCertEntity) {
        return suppliersEnterpriseBasicCertDao.updateCompanyCert(supplierEnterpriseBasicCertEntity);
    }

    @Override
    public boolean insertCompanyCert(SupplierEnterpriseBasicCertEntity supplierEnterpriseBasicCertEntity) {
        return suppliersEnterpriseBasicCertDao.insertCompanyCert(supplierEnterpriseBasicCertEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return suppliersEnterpriseBasicCertDao.deleteById(id);
    }

    @Override
    public boolean deleteByEnterpriseId(String enterpriseId) {
        return suppliersEnterpriseBasicCertDao.deleteByEnterpriseId(enterpriseId);
    }

}
