package com.glxp.sale.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.info.SuppliersRegistrationBasicDao;
import com.glxp.sale.admin.entity.info.SuppliersRegistrationBasicEntity;
import com.glxp.sale.admin.req.info.SuppliersRegistrationBasicRequest;
import com.glxp.sale.admin.service.info.SuppliersRegistrationBasicService;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class SuppliersRegistrationBasicServiceImpl implements SuppliersRegistrationBasicService {

    @Resource
    SuppliersRegistrationBasicDao suppliersRegistrationBasicDao;

    @Override
    public SuppliersRegistrationBasicEntity findRegistration(Long id) {
        return suppliersRegistrationBasicDao.findRegistration(id);
    }

    @Override
    public SuppliersRegistrationBasicEntity findRegistrationByName(String recordProductName) {
        return suppliersRegistrationBasicDao.findRegistrationByName(recordProductName);
    }

    @Override
    public List<SuppliersRegistrationBasicEntity> getRegistration(SuppliersRegistrationBasicRequest suppliersRegistrationBasicRequest) {
        if (suppliersRegistrationBasicRequest == null) {
            return Collections.emptyList();
        }
        int offset = (suppliersRegistrationBasicRequest.getPage() - 1) * suppliersRegistrationBasicRequest.getLimit();
        PageHelper.offsetPage(offset, suppliersRegistrationBasicRequest.getLimit());
        List<SuppliersRegistrationBasicEntity> companyEntities = suppliersRegistrationBasicDao.getRegistration(suppliersRegistrationBasicRequest);
        return companyEntities;
    }

    @Override
    public boolean modifyRegistration(SuppliersRegistrationBasicEntity companyEntity) {
        return suppliersRegistrationBasicDao.modifyRegistration(companyEntity);
    }

    @Override
    public boolean insertRegistration(SuppliersRegistrationBasicEntity companyEntity) {
        return suppliersRegistrationBasicDao.insertRegistration(companyEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return suppliersRegistrationBasicDao.deleteById(id);
    }

    @Override
    public boolean deleteByEnterpriseId(String enterpriseId) {
        return suppliersRegistrationBasicDao.deleteByEnterpriseId(enterpriseId);
    }
}
