package com.glxp.sale.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.inout.CodesDao;
import com.glxp.sale.admin.entity.inout.WarehouseEntity;
import com.glxp.sale.admin.req.inout.WarehouseQueryRequest;
import com.glxp.sale.admin.service.inout.CodesService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CodesServiceImpl implements CodesService {

    @Resource
    CodesDao codesDao;

    @Override
    public List<WarehouseEntity> listWarehouse(WarehouseQueryRequest warehouseQueryRequest) {
        if (warehouseQueryRequest == null) {
            return Collections.emptyList();
        }
        int offset = (warehouseQueryRequest.getPage() - 1) * warehouseQueryRequest.getLimit();
        PageHelper.offsetPage(offset, warehouseQueryRequest.getLimit());
        return codesDao.listWarehouse(warehouseQueryRequest);
    }


    @Override
    public boolean insertWarehouse(WarehouseEntity warehouseEntity) {
        return codesDao.insertWarehouse(warehouseEntity);
    }

    @Override
    public boolean insertWarehouses(List<WarehouseEntity> warehouseEntities) {
        return codesDao.insertWarehouses(warehouseEntities);
    }


    @Override
    public List<WarehouseEntity> findByNo(WarehouseQueryRequest warehouseQueryRequest) {
        if (warehouseQueryRequest == null) {
            return Collections.emptyList();
        }
        int offset = (warehouseQueryRequest.getPage() - 1) * warehouseQueryRequest.getLimit();
        PageHelper.offsetPage(offset, warehouseQueryRequest.getLimit());
        return codesDao.findByNo(warehouseQueryRequest);
    }

    @Override
    public boolean isExits(WarehouseEntity warehouseEntity) {

        int result = codesDao.isExit(warehouseEntity);
        if (result == 1)
            return true;
        else
            return false;
    }

    @Override
    public List<WarehouseEntity> findByOrderId(WarehouseQueryRequest warehouseQueryRequest) {
        if (warehouseQueryRequest == null) {
            return Collections.emptyList();
        }
        if (warehouseQueryRequest.getPage() != null) {
            int offset = (warehouseQueryRequest.getPage() - 1) * warehouseQueryRequest.getLimit();
            PageHelper.offsetPage(offset, warehouseQueryRequest.getLimit());
        }

        return codesDao.findByOrderId(warehouseQueryRequest);
    }

    @Override
    public List<WarehouseEntity> findAllByOrderId(WarehouseQueryRequest warehouseQueryRequest) {
        if (warehouseQueryRequest == null) {
            return Collections.emptyList();
        }
        return codesDao.findByOrderId(warehouseQueryRequest);
    }

    @Override
    public List<WarehouseEntity> findByReceiptId(String orderId) {
        return codesDao.findByReceiptId(orderId);
    }


    @Override
    public List<WarehouseEntity> findByCode(String code) {

        return codesDao.findByCode(code);
    }

    @Override
    public boolean updateOrderId(String oldOrderId, String newOrderId) {


        return codesDao.updateOrderId(oldOrderId, newOrderId);
    }

    @Override
    public List<WarehouseEntity> searchCode(String code) {
        return codesDao.searchCode(code);
    }


    @Override
    public boolean updateUnit(String orderId, String fromCorpId, String fromCorp) {
        return codesDao.updateUnit(orderId, fromCorpId, fromCorp);
    }
}
