package com.glxp.sale.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.inout.OrderDetailDao;
import com.glxp.sale.admin.entity.inout.ErpOrderEntity;
import com.glxp.sale.admin.entity.inout.FilterErpOrderRequest;
import com.glxp.sale.admin.service.inout.OrderDetailService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class OrderDetailServiceImpl implements OrderDetailService {

    @Resource
    OrderDetailDao orderDetailDao;

    @Override
    public List<ErpOrderEntity> filterAllMyErpOrder(FilterErpOrderRequest filterErpOrderRequest) {
        if (filterErpOrderRequest == null) {
            return Collections.emptyList();
        }

        return orderDetailDao.filterMyErpOrder(filterErpOrderRequest);
    }

    @Override
    public List<ErpOrderEntity> findByStockCheck(FilterErpOrderRequest filterErpOrderRequest) {

        if (filterErpOrderRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterErpOrderRequest.getPage() - 1) * filterErpOrderRequest.getLimit();
        PageHelper.offsetPage(offset, filterErpOrderRequest.getLimit());
        return orderDetailDao.findByStockCheck(filterErpOrderRequest.getOrderIds());
    }

    @Override
    public List<ErpOrderEntity> filterMyErpOrder(FilterErpOrderRequest filterErpOrderRequest) {
        if (filterErpOrderRequest == null) {
            return Collections.emptyList();
        }
        if (filterErpOrderRequest.getPage() != null) {
            int offset = (filterErpOrderRequest.getPage() - 1) * filterErpOrderRequest.getLimit();
            PageHelper.offsetPage(offset, filterErpOrderRequest.getLimit());
        }
        return orderDetailDao.filterMyErpOrder(filterErpOrderRequest);
    }

    @Override
    public List<ErpOrderEntity> filterMyErpMainOrder(FilterErpOrderRequest filterErpOrderRequest) {
        if (filterErpOrderRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterErpOrderRequest.getPage() - 1) * filterErpOrderRequest.getLimit();
        PageHelper.offsetPage(offset, filterErpOrderRequest.getLimit());
        return orderDetailDao.filterMyErpMainOrder(filterErpOrderRequest);
    }

    @Override
    public List<ErpOrderEntity> filterMyErpDetailOrder(FilterErpOrderRequest filterErpOrderRequest) {
        if (filterErpOrderRequest == null) {
            return Collections.emptyList();
        }
        if (filterErpOrderRequest.getPage() != null && filterErpOrderRequest.getLimit() != null) {
            int offset = (filterErpOrderRequest.getPage() - 1) * filterErpOrderRequest.getLimit();
            PageHelper.offsetPage(offset, filterErpOrderRequest.getLimit());
        }

        return orderDetailDao.filterMyErpDetailOrder(filterErpOrderRequest);
    }

    @Override
    public List<ErpOrderEntity> findAllByDocids(List<String> docids) {
        return orderDetailDao.findAllByDocids(docids);
    }

    @Override
    public List<String> filterAllDocid(FilterErpOrderRequest filterErpOrderRequest) {
        return orderDetailDao.filterAllDocid(filterErpOrderRequest);
    }

    @Override
    public List<ErpOrderEntity> filterAllDocidE(FilterErpOrderRequest filterErpOrderRequest) {
        return orderDetailDao.filterAllDocidE(filterErpOrderRequest);
    }

    @Override
    public boolean insertErpOrders(List<ErpOrderEntity> erpOrderEntities) {
        return orderDetailDao.insertErpOrders(erpOrderEntities);
    }

    @Override
    public boolean insertErpOrder(ErpOrderEntity erpOrderEntity) {
        return orderDetailDao.insertErpOrder(erpOrderEntity);
    }

    @Override
    public boolean updateErpOrder(ErpOrderEntity erpOrderEntity) {
        return orderDetailDao.updateErpOrder(erpOrderEntity);
    }

    @Override
    public List<String> selectAllIds(List<String> docids) {
        return orderDetailDao.selectAllIds(docids);
    }

    @Override
    public boolean deleteById(String id) {
        return orderDetailDao.deleteById(id);
    }

    @Override
    public boolean deleteByPrimiyId(String id) {
        return orderDetailDao.deleteByPrimiyId(id);
    }

    @Override
    public boolean deleteByOrderId(String id) {
        return orderDetailDao.deleteByOrderId(id);
    }

}
