package com.glxp.sale.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.inout.StockQRCodeTextDao;
import com.glxp.sale.admin.entity.inout.StockQRCodeTextEntity;
import com.glxp.sale.admin.req.inout.StockQRCodeTextFilterRequest;
import com.glxp.sale.admin.service.inout.StockQRCodeTextService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class StockQRCodeTextServiceImpl implements StockQRCodeTextService {

    @Resource
    StockQRCodeTextDao stockQRCodeTextDao;

    @Override
    public List<StockQRCodeTextEntity> filterStockQRCodeText(StockQRCodeTextFilterRequest stockQRCodeTextFilterRequest) {
        if (stockQRCodeTextFilterRequest == null) {
            return Collections.emptyList();
        }
        if (stockQRCodeTextFilterRequest.getPage() != null) {
            int offset = (stockQRCodeTextFilterRequest.getPage() - 1) * stockQRCodeTextFilterRequest.getLimit();
            PageHelper.offsetPage(offset, stockQRCodeTextFilterRequest.getLimit());
        }
        return stockQRCodeTextDao.filterStockQRCodeText(stockQRCodeTextFilterRequest);
    }

    @Override
    public boolean insertStockQRCodeText(StockQRCodeTextEntity stockQRCodeTextEntity) {
        return stockQRCodeTextDao.insertStockQRCodeText(stockQRCodeTextEntity);
    }

    @Override
    public boolean insertStockQRCodeTexts(List<StockQRCodeTextEntity> StockQRCodeTextEntitys) {
        return stockQRCodeTextDao.insertStockQRCodeTexts(StockQRCodeTextEntitys);
    }

    @Override
    public boolean updateById(StockQRCodeTextEntity stockQRCodeTextEntity) {
        return stockQRCodeTextDao.updateById(stockQRCodeTextEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return stockQRCodeTextDao.deleteById(id);
    }
    @Override
    public boolean deleteByOrderId(String id) {
        return stockQRCodeTextDao.deleteByOrderId(id);
    }

    @Override
    public StockQRCodeTextEntity findOne(String id) {
        return stockQRCodeTextDao.findOne(id);
    }

}
