package com.glxp.sale.admin.service.param.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.param.SystemExcelTemplateDao;
import com.glxp.sale.admin.entity.param.SystemExcelTemplateEntity;
import com.glxp.sale.admin.req.param.SystemExcelTemplateRequest;
import com.glxp.sale.admin.service.param.SystemExcelTamplateService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class SystemExcelTamplateServiceImpl implements SystemExcelTamplateService {

    @Resource
    SystemExcelTemplateDao systemExcelTemplateDao;

    @Override
    public List<SystemExcelTemplateEntity> filterSystemExcelTemplate(SystemExcelTemplateRequest systemExcelTemplateRequest) {
        if (systemExcelTemplateRequest == null) {
            return Collections.emptyList();
        }
        if (systemExcelTemplateRequest.getPage() != null) {
            int offset = (systemExcelTemplateRequest.getPage() - 1) * systemExcelTemplateRequest.getLimit();
            PageHelper.offsetPage(offset, systemExcelTemplateRequest.getLimit());
        }
        return systemExcelTemplateDao.filterSystemExcelTemplate(systemExcelTemplateRequest);
    }

    @Override
    public List<SystemExcelTemplateEntity> getSystemExcelTemplate(SystemExcelTemplateRequest filterSystemExcelTemplateRequest) {
        if (filterSystemExcelTemplateRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterSystemExcelTemplateRequest.getPage() - 1) * filterSystemExcelTemplateRequest.getLimit();
        PageHelper.offsetPage(offset, filterSystemExcelTemplateRequest.getLimit());
        List<SystemExcelTemplateEntity> companyEntities = systemExcelTemplateDao.getSystemExcelTemplate(filterSystemExcelTemplateRequest);
        return companyEntities;
    }

    @Override
    public SystemExcelTemplateEntity findSystemExcelTemplateByName(String companyName) {
        return systemExcelTemplateDao.findSystemExcelTemplateByName(companyName);
    }

    @Override
    public boolean updateSystemExcelTemplate(SystemExcelTemplateEntity companyCertEntity) {
        return systemExcelTemplateDao.updateSystemExcelTemplate(companyCertEntity);
    }

    @Override
    public boolean insertSystemExcelTemplate(SystemExcelTemplateEntity companyCertEntity) {
        return systemExcelTemplateDao.insertSystemExcelTemplate(companyCertEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return systemExcelTemplateDao.deleteById(id);
    }
}
