package com.glxp.sale.admin.service.param.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.param.SystemPDFModuleDao;
import com.glxp.sale.admin.entity.param.SystemPDFModuleEntity;
import com.glxp.sale.admin.req.param.SystemPDFModuleRequest;
import com.glxp.sale.admin.req.param.SystemPDFModuleSaveRequest;
import com.glxp.sale.admin.service.param.SystemPDFModuleService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class SystemPDFModuleServiceImpl implements SystemPDFModuleService {
    @Resource
    SystemPDFModuleDao systemPDFModuleDao;

    @Override
    public List<SystemPDFModuleEntity> queryPage(SystemPDFModuleRequest SystemPDFModuleRequest) {
        int offset = (SystemPDFModuleRequest.getPage() - 1) * SystemPDFModuleRequest.getLimit();
        PageHelper.offsetPage(offset, SystemPDFModuleRequest.getLimit());
        List<SystemPDFModuleEntity> list = systemPDFModuleDao.queryPage(SystemPDFModuleRequest);
        return list;
    }

    @Override
    public List<SystemPDFModuleEntity> listPDFModules(Integer page, Integer limit) {
        page = page != null && page > 0 ? page : 1;
        limit = limit != null && limit > 0 && limit < 100 ? limit : 100;
        int offset = (page - 1) * limit;
        PageHelper.offsetPage(offset, limit);
        List<SystemPDFModuleEntity> list = systemPDFModuleDao.listPDFModules();
        return list;
    }

    @Override
    public SystemPDFModuleEntity findSystemPDFModule(SystemPDFModuleRequest systemPDFModuleRequest) {
        return systemPDFModuleDao.findSystemPDFModule(systemPDFModuleRequest);
    }

    @Override
    public SystemPDFModuleEntity selectById(String id) {
        return systemPDFModuleDao.selectById(id);
    }

    @Override
    public boolean updateById(SystemPDFModuleSaveRequest systemPDFModuleSaveRequest) {

        return systemPDFModuleDao.updateById(systemPDFModuleSaveRequest);
    }

    @Override
    public boolean insert(SystemPDFModuleEntity systemPDFModuleEntity) {
        return systemPDFModuleDao.insert(systemPDFModuleEntity);
    }

    @Override
    public boolean deleteById(Integer id) {
        return systemPDFModuleDao.deleteById(id);
    }
}
