package com.glxp.sale.admin.service.param.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.param.SystemPDFTemplateDao;
import com.glxp.sale.admin.entity.auth.AuthRole;
import com.glxp.sale.admin.entity.param.SystemPDFTemplateEntity;
import com.glxp.sale.admin.entity.param.SystemPDFTemplateEntity;
import com.glxp.sale.admin.req.param.SystemPDFTemplateRequest;
import com.glxp.sale.admin.req.param.SystemPDFTemplateSaveRequest;
import com.glxp.sale.admin.req.param.SystemPDFTemplateRequest;
import com.glxp.sale.admin.service.param.SystemPDFTemplateService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class SystemPDFTemplateServiceImpl implements SystemPDFTemplateService {
    @Resource
    SystemPDFTemplateDao systemPDFTemplateDao;

    @Override
    public List<SystemPDFTemplateEntity> queryPage(SystemPDFTemplateRequest SystemPDFTemplateRequest) {
        int offset = (SystemPDFTemplateRequest.getPage() - 1) * SystemPDFTemplateRequest.getLimit();
        PageHelper.offsetPage(offset, SystemPDFTemplateRequest.getLimit());
        List<SystemPDFTemplateEntity> list = systemPDFTemplateDao.queryPage(SystemPDFTemplateRequest);
        return list;
    }

    @Override
    public List<SystemPDFTemplateEntity> listPDFTemplates(Integer page, Integer limit) {
        page = page != null && page > 0 ? page : 1;
        limit = limit != null && limit > 0 && limit < 100 ? limit : 100;
        int offset = (page - 1) * limit;
        PageHelper.offsetPage(offset, limit);
        List<SystemPDFTemplateEntity> list = systemPDFTemplateDao.listPDFTemplates();
        return list;
    }

    @Override
    public SystemPDFTemplateEntity findSystemPDFTemplate(SystemPDFTemplateRequest systemPDFTemplateRequest) {
        return systemPDFTemplateDao.findSystemPDFTemplate(systemPDFTemplateRequest);
    }

    @Override
    public SystemPDFTemplateEntity selectById(String id) {
        return systemPDFTemplateDao.selectById(id);
    }

    @Override
    public boolean updateById(SystemPDFTemplateSaveRequest systemPDFTemplateSaveRequest) {

        return systemPDFTemplateDao.updateById(systemPDFTemplateSaveRequest);
    }

    @Override
    public boolean insert(SystemPDFTemplateEntity systemPDFTemplateEntity) {
        return systemPDFTemplateDao.insert(systemPDFTemplateEntity);
    }

    @Override
    public boolean deleteById(Integer id) {
        return systemPDFTemplateDao.deleteById(id);
    }
}
