package com.glxp.sale.admin.service.receipt.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.receipt.MipsBarcodeDao;
import com.glxp.sale.admin.entity.receipt.MipsBarcodeEntity;
import com.glxp.sale.admin.entity.receipt.StockDetailEntity;
import com.glxp.sale.admin.req.receipt.FilterBatchnoCount;
import com.glxp.sale.admin.req.receipt.FilterStockRequest;
import com.glxp.sale.admin.req.receipt.MipsBarcodeRequest;
import com.glxp.sale.admin.service.receipt.MipsBarcodeService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class MipsBarcodeServiceImpl implements MipsBarcodeService {
    @Resource
    MipsBarcodeDao mipsBarcodeDao;

    @Override
    public List<MipsBarcodeEntity> filterAll(MipsBarcodeRequest mipsBarcodeRequest) {
        List<MipsBarcodeEntity> data = mipsBarcodeDao.filterBarcodes(mipsBarcodeRequest);
        return data;
    }

    @Override
    public List<MipsBarcodeEntity> selectByOrderId(MipsBarcodeRequest mipsBarcodeRequest) {
        if (mipsBarcodeRequest == null) {
            return Collections.emptyList();
        }
        int offset = (mipsBarcodeRequest.getPage() - 1) * mipsBarcodeRequest.getLimit();
        PageHelper.offsetPage(offset, mipsBarcodeRequest.getLimit());
        List<MipsBarcodeEntity> data = mipsBarcodeDao.selectByOrderId(mipsBarcodeRequest.getOrderId());
        return data;
    }

    @Override
    public List<MipsBarcodeEntity> selectAllByOrderId(String orderId) {
        List<MipsBarcodeEntity> data = mipsBarcodeDao.selectByOrderId(orderId);
        return data;
    }

    @Override
    public List<MipsBarcodeEntity> filterBarcodes(MipsBarcodeRequest mipsBarcodeRequest) {
        if (mipsBarcodeRequest == null) {
            return Collections.emptyList();
        }
        int offset = (mipsBarcodeRequest.getPage() - 1) * mipsBarcodeRequest.getLimit();
        PageHelper.offsetPage(offset, mipsBarcodeRequest.getLimit());
        List<MipsBarcodeEntity> data = mipsBarcodeDao.filterBarcodes(mipsBarcodeRequest);
        return data;
    }

    @Override
    public List<StockDetailEntity> filterStock(FilterStockRequest filterStockRequest) {
        if (filterStockRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterStockRequest.getPage() - 1) * filterStockRequest.getLimit();
        PageHelper.offsetPage(offset, filterStockRequest.getLimit());
        List<StockDetailEntity> data = mipsBarcodeDao.filterStock(filterStockRequest);
        return data;
    }

    @Override
    public Integer selectCountByBatchno(FilterBatchnoCount filterBatchnoCount) {
        return mipsBarcodeDao.selectCountByBatchno(filterBatchnoCount);
    }

    @Override
    public boolean insertList(List<MipsBarcodeEntity> barcodeEntities) {
        return mipsBarcodeDao.insertList(barcodeEntities);
    }

    @Override
    public boolean deleteByCodes(List<String> codes) {
        return mipsBarcodeDao.deleteByCodes(codes);
    }

    @Override
    public boolean deleteByOrderId(String orderId) {
        return mipsBarcodeDao.deleteByOrderId(orderId);
    }

    @Override
    public boolean updateDtFlag(List<String> codes) {
        return mipsBarcodeDao.updateDtFlag(codes);
    }
}
