package com.glxp.sale.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.sale.admin.dao.thrsys.ThrProductsDao;
import com.glxp.sale.admin.entity.thrsys.ThrProductsEntity;
import com.glxp.sale.admin.req.thrsys.FilterThrProductsRequest;
import com.glxp.sale.admin.service.thrsys.ThrProductsService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrProductsServiceImpl implements ThrProductsService {


    @Resource
    ThrProductsDao thrProductsDao;


    @Override
    public List<ThrProductsEntity> filterThrProductsRequest(FilterThrProductsRequest filterThrProductsRequest) {
        if (filterThrProductsRequest == null) {
            return Collections.emptyList();
        }
        if (filterThrProductsRequest.getPage() != null) {
            int offset = (filterThrProductsRequest.getPage() - 1) * filterThrProductsRequest.getLimit();
            PageHelper.offsetPage(offset, filterThrProductsRequest.getLimit());
        }
        List<ThrProductsEntity> data = thrProductsDao.filterThrProductsRequest(filterThrProductsRequest);
        return data;
    }

    @Override
    public ThrProductsEntity selectById(String id) {
        return thrProductsDao.selectById(id);
    }

    @Override
    public boolean insertThrProducts(ThrProductsEntity thrProductsEntity) {
        return thrProductsDao.insertThrProducts(thrProductsEntity);
    }

    @Override
    public boolean insertThrProductss(List<ThrProductsEntity> thrProductsEntities) {
        return thrProductsDao.insertThrProductss(thrProductsEntities);
    }

    @Override
    public boolean updateThrProducts(ThrProductsEntity thrProductsEntity) {
        return thrProductsDao.updateThrProducts(thrProductsEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrProductsDao.deleteById(id);
    }

    @Override
    public boolean deleteAll() {
        return thrProductsDao.deleteAll();
    }
}
