package com.glxp.sale.admin.thread;

import com.glxp.sale.admin.entity.basic.UdiInfoEntity;
import com.glxp.sale.admin.entity.basic.UdiRelevanceEntity;
import com.glxp.sale.admin.entity.param.SystemParamConfigEntity;
import com.glxp.sale.admin.entity.thrsys.ThrProductsEntity;
import com.glxp.sale.admin.httpclient.ErpBasicClient;
import com.glxp.sale.admin.req.basic.FilterErpGoodsRequest;
import com.glxp.sale.admin.req.thrsys.FilterThrProductsRequest;
import com.glxp.sale.admin.res.PageSimpleResponse;
import com.glxp.sale.admin.res.basic.ErpProductsResponse;
import com.glxp.sale.admin.service.basic.UdiInfoService;
import com.glxp.sale.admin.service.basic.UdiRelevanceService;
import com.glxp.sale.admin.service.param.SystemParamConfigService;
import com.glxp.sale.admin.service.thrsys.ThrProductsService;
import com.glxp.sale.admin.util.CustomUtil;
import com.glxp.sale.admin.util.DateUtil;
import com.glxp.sale.common.res.BaseResponse;
import org.springframework.beans.BeanUtils;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class BasicBackUpdateProductService {
    @Resource
    UdiRelevanceService udiRelevanceService;
    @Resource
    UdiInfoService udiInfoService;
    @Resource
    ThrProductsService thrProductsService;
    @Resource
    SystemParamConfigService systemParamConfigService;


    //定时或一键下载更新全部线上产品信息
    @Async
    public void addAllProducts(FilterErpGoodsRequest filterErpGoodsRequest, String productUrl, String onHandUrl, String thirdSysId, Boolean isEnable) {
        int page = 1;
        if (filterErpGoodsRequest == null) {
            filterErpGoodsRequest = new FilterErpGoodsRequest();
        }
        filterErpGoodsRequest.setPage(1);
        filterErpGoodsRequest.setLimit(100);
        while (page != -1) {
            page = getAllProducts(filterErpGoodsRequest, productUrl, onHandUrl, thirdSysId, isEnable);
        }
    }

    //定时或一键下载更新全部线上产品信息
    public int getAllProducts(FilterErpGoodsRequest filterErpGoodsRequest, String productUrl, String
            onHandUrl, String thirdSysId, Boolean isEnable) {

        BaseResponse<PageSimpleResponse<ErpProductsResponse>> erpProducts = new ErpBasicClient().getErpProducts(filterErpGoodsRequest, productUrl);
        List<ErpProductsResponse> invmandocResponses = erpProducts.getData().getList();
        SystemParamConfigEntity isUpdate = systemParamConfigService.selectByParamKey("erp_updateErpData_type");
        if (isEnable == null || isEnable == false) {
            isUpdate.setParamValue("1");
        }
        Map<String, ErpProductsResponse> erpProductsMap = new HashMap<>();
        if (invmandocResponses != null && invmandocResponses.size() > 0) {
            List<String> inventoryCodes = new ArrayList<>();
//            if (filterErpGoodsRequest.getCode() != null) {
//                inventoryCodes.add(filterErpGoodsRequest.getCode());
//                erpProductsMap.put(filterErpGoodsRequest.getCode(), invmandocResponses.get(0));
//            } else {
            for (ErpProductsResponse invmandocResponse : invmandocResponses) {
                UdiRelevanceEntity udiRelevanceEntity = udiRelevanceService.selectByThirdId(invmandocResponse.getCode(), thirdSysId);
                if (udiRelevanceEntity == null) {
                    inventoryCodes.add(invmandocResponse.getCode());
                    erpProductsMap.put(invmandocResponse.getCode(), invmandocResponse);
                    if (isUpdate.getParamValue().equals("1")) {//不根据库存信息过滤
                        UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
                        udiInfoEntity.setNameCode(invmandocResponse.getCode());
                        udiInfoEntity.setCpmctymc(invmandocResponse.getName());
                        udiInfoEntity.setGgxh(invmandocResponse.getSpec());
                        udiInfoEntity.setUuid(CustomUtil.getUUId());
                        udiInfoEntity.setDiType(1);

                        udiInfoEntity.setManufactory(invmandocResponses.get(0).getManufactory());
                        udiInfoEntity.setYlqxzcrbarmc(invmandocResponses.get(0).getManufactory());
                        udiInfoEntity.setZczbhhzbapzbh(invmandocResponses.get(0).getRegisterNo());
                        udiInfoService.insertUdiInfo(udiInfoEntity);
                        UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
                        udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());
                        if ("thirdId".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId(invmandocResponse.getCode());
                            udiRelevanceEntity1.setThirdName(invmandocResponse.getName());
                        } else if ("thirdId1".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId1(invmandocResponse.getCode());
                            udiRelevanceEntity1.setThirdName1(invmandocResponse.getName());
                        } else if ("thirdId2".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId4(invmandocResponse.getCode());
                            udiRelevanceEntity1.setThirdName4(invmandocResponse.getName());
                        } else if ("thirdId3".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId3(invmandocResponse.getCode());
                            udiRelevanceEntity1.setThirdName3(invmandocResponse.getName());
                        } else if ("thirdId4".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId4(invmandocResponse.getCode());
                            udiRelevanceEntity1.setThirdName4(invmandocResponse.getName());
                        }
                        udiRelevanceEntity1.setThirdId(invmandocResponse.getCode());
                        udiRelevanceEntity1.setThirdName(invmandocResponse.getName());
                        udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
                        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
                    }
                }

//                }
            }

            //若需要对照库存信息
            if (!isUpdate.getParamValue().equals("1")) {
            }

            filterErpGoodsRequest.setPage(filterErpGoodsRequest.getPage() + 1);
            if (filterErpGoodsRequest.getPage() * filterErpGoodsRequest.getLimit() < erpProducts.getData().getTotal()) {
                return filterErpGoodsRequest.getPage();
            }
        } else {
            return -1;
        }

        return -1;
    }


    //定时或一键下载更新本地所有产品信息
    @Async
    public void loadLocal(FilterErpGoodsRequest filterErpGoodsRequest, String thirdSysId, String onHandUrl, Boolean isEnable) {
        if (filterErpGoodsRequest == null) {
            filterErpGoodsRequest = new FilterErpGoodsRequest();
        }
        FilterThrProductsRequest filterThrInvProductsRequest = new FilterThrProductsRequest();
        BeanUtils.copyProperties(filterErpGoodsRequest, filterThrInvProductsRequest);
        filterThrInvProductsRequest.setPage(null);
        List<ThrProductsEntity> thrProductsEntities = thrProductsService.filterThrProductsRequest(filterThrInvProductsRequest);

        SystemParamConfigEntity isUpdate = systemParamConfigService.selectByParamKey("erp_updateErpData_type");
        if (isEnable == null || isEnable == false) {
            isUpdate.setParamValue("1");
        }

        if (thrProductsEntities != null && thrProductsEntities.size() > 0) {
            for (ThrProductsEntity thrProductsEntity : thrProductsEntities) {
                UdiRelevanceEntity udiRelevanceEntity = udiRelevanceService.selectByThirdId(thrProductsEntity.getCode(), thirdSysId);
                if (udiRelevanceEntity == null){
                    if (isUpdate.getParamValue().equals("1")) {

                        UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
                        udiInfoEntity.setNameCode(thrProductsEntity.getCode());
                        udiInfoEntity.setCpmctymc(thrProductsEntity.getName());
                        udiInfoEntity.setGgxh(thrProductsEntity.getSpec());
                        udiInfoEntity.setUuid(CustomUtil.getUUId());
                        udiInfoEntity.setDiType(1);
                        udiInfoEntity.setManufactory(thrProductsEntity.getManufactory());
                        udiInfoEntity.setYlqxzcrbarmc(thrProductsEntity.getManufactory());
                        udiInfoEntity.setZczbhhzbapzbh(thrProductsEntity.getRegisterNo());
                        udiInfoService.insertUdiInfo(udiInfoEntity);
                        UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
                        udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());


                        if ("thirdId".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId(thrProductsEntity.getCode());
                            udiRelevanceEntity1.setThirdName(thrProductsEntity.getName());
                        } else if ("thirdId1".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId1(thrProductsEntity.getCode());
                            udiRelevanceEntity1.setThirdName1(thrProductsEntity.getName());
                        } else if ("thirdId2".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId4(thrProductsEntity.getCode());
                            udiRelevanceEntity1.setThirdName4(thrProductsEntity.getName());
                        } else if ("thirdId3".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId3(thrProductsEntity.getCode());
                            udiRelevanceEntity1.setThirdName3(thrProductsEntity.getName());
                        } else if ("thirdId4".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId4(thrProductsEntity.getCode());
                            udiRelevanceEntity1.setThirdName4(thrProductsEntity.getName());
                        }

                        udiRelevanceEntity1.setThirdId(thrProductsEntity.getCode());
                        udiRelevanceEntity1.setThirdName(thrProductsEntity.getName());
                        udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
                        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
                    }
                }

            }
        }


    }




}
