package com.glxp.sale.admin.thread;

import com.glxp.sale.admin.entity.basic.BasicThirdSysDetailEntity;
import com.glxp.sale.admin.entity.basic.BasicUnitMaintainEntity;
import com.glxp.sale.admin.httpclient.ErpBasicClient;
import com.glxp.sale.admin.req.basic.BasicUnitMaintainFilterRequest;
import com.glxp.sale.admin.res.PageSimpleResponse;
import com.glxp.sale.admin.res.basic.ErpUnitsResponse;
import com.glxp.sale.admin.service.basic.BasicUnitMaintainService;
import com.glxp.sale.admin.util.CustomUtil;
import com.glxp.sale.common.res.BaseResponse;
import org.springframework.beans.BeanUtils;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

@Service
public class BasicUnitImportService {
    @Resource
    private BasicUnitMaintainService basicUnitMaintainService;



    @Async
    public void selectAllUnit(BasicThirdSysDetailEntity basicThirdSysDetailEntity, BasicUnitMaintainFilterRequest unitMaintainFilterRequest) {
        List<ErpUnitsResponse> imports = new ArrayList<>();
        if (basicThirdSysDetailEntity.getFromType() == 0) {
            int page = 1;

            List<ErpUnitsResponse> erpUnitsResponses = new ArrayList<>();
            while (true) {
                unitMaintainFilterRequest.setPage(page);
                unitMaintainFilterRequest.setLimit(100);
                BaseResponse<PageSimpleResponse<ErpUnitsResponse>> baseResponse =
                        new ErpBasicClient().getErpCrop(unitMaintainFilterRequest, basicThirdSysDetailEntity.getValue());
                List<ErpUnitsResponse> temps = baseResponse.getData().getList();
                if (temps.size() < 100) {
                    erpUnitsResponses.addAll(temps);
                    break;
                } else {
                    page++;
                    erpUnitsResponses.addAll(temps);
                }
            }

            imports.addAll(erpUnitsResponses);

        } else {
        }
        if (imports != null && imports.size() > 0) {
            for (ErpUnitsResponse erpUnitsResponse : imports) {
                BasicUnitMaintainEntity basicUnitMaintainEntity = new BasicUnitMaintainEntity();
                if (unitMaintainFilterRequest.getThirdSys() != null) {
                    if ("thirdId".equals(unitMaintainFilterRequest.getThirdSys())) {
                        basicUnitMaintainEntity.setThirdId(erpUnitsResponse.getId());
                        basicUnitMaintainEntity.setThirdName(erpUnitsResponse.getName());
                    } else if ("thirdId1".equals(unitMaintainFilterRequest.getThirdSys())) {
                        basicUnitMaintainEntity.setThirdId1(erpUnitsResponse.getId());
                        basicUnitMaintainEntity.setThirdName1(erpUnitsResponse.getName());
                    } else if ("thirdId2".equals(unitMaintainFilterRequest.getThirdSys())) {
                        basicUnitMaintainEntity.setThirdId2(erpUnitsResponse.getId());
                        basicUnitMaintainEntity.setThirdName2(erpUnitsResponse.getName());
                    } else if ("thirdId3".equals(unitMaintainFilterRequest.getThirdSys())) {
                        basicUnitMaintainEntity.setThirdId3(erpUnitsResponse.getId());
                        basicUnitMaintainEntity.setThirdName3(erpUnitsResponse.getName());
                    } else if ("thirdId4".equals(unitMaintainFilterRequest.getThirdSys())) {
                        basicUnitMaintainEntity.setThirdId4(erpUnitsResponse.getId());
                        basicUnitMaintainEntity.setThirdName4(erpUnitsResponse.getName());
                    }
                }
                basicUnitMaintainEntity.setErpId(CustomUtil.getId());
                basicUnitMaintainEntity.setName(erpUnitsResponse.getName());
                basicUnitMaintainEntity.setSpell(erpUnitsResponse.getSpell());
                basicUnitMaintainEntity.setAddr(erpUnitsResponse.getAddr());
                basicUnitMaintainEntity.setCreditNo(erpUnitsResponse.getCreditNo());
                basicUnitMaintainEntity.setContact(erpUnitsResponse.getContact());
                basicUnitMaintainEntity.setMobile(erpUnitsResponse.getMobile());
                basicUnitMaintainService.insertBasicUnitMaintain(basicUnitMaintainEntity);
            }
        }
    }
}
