package com.glxp.sale.admin.thread;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.glxp.sale.admin.entity.basic.BasicThirdSysDetailEntity;
import com.glxp.sale.admin.entity.basic.UdiInfoEntity;
import com.glxp.sale.admin.entity.basic.UdiRelevanceEntity;
import com.glxp.sale.admin.entity.thrsys.ThrProductsEntity;
import com.glxp.sale.admin.entity.udid.UdiEntity;
import com.glxp.sale.admin.httpclient.ErpBasicClient;
import com.glxp.sale.admin.req.basic.CombineRequest;
import com.glxp.sale.admin.req.basic.FilterErpGoodsRequest;
import com.glxp.sale.admin.req.basic.FilterUdiInfoRequest;
import com.glxp.sale.admin.req.thrsys.FilterThrProductsRequest;
import com.glxp.sale.admin.res.PageSimpleResponse;
import com.glxp.sale.admin.res.basic.ErpProductsResponse;
import com.glxp.sale.admin.service.basic.BasicThirdSysDetailService;
import com.glxp.sale.admin.service.basic.UdiInfoService;
import com.glxp.sale.admin.service.basic.UdiRelevanceService;
import com.glxp.sale.admin.service.param.SystemParamConfigService;
import com.glxp.sale.admin.service.thrsys.ThrProductsService;
import com.glxp.sale.admin.util.CustomUtil;
import com.glxp.sale.admin.util.DateUtil;
import com.glxp.sale.admin.util.FilterUdiUtils;
import com.glxp.sale.admin.util.HttpClient;
import com.glxp.sale.common.res.BaseResponse;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class BasicUpdateProductService {

    @Value("${UDI_SERVER_URL}")
    private String udiUrl;

    @Resource
    UdiRelevanceService udiRelevanceService;
    @Resource
    UdiInfoService udiInfoService;
    @Resource
    ThrProductsService thrProductsService;
    @Resource
    SystemParamConfigService systemParamConfigService;
    @Resource
    BasicThirdSysDetailService basicThirdSysDetailService;


    public String addProduct(CombineRequest combineRequest, String url) {
        String errMsg = null;
        List<String> inventoryCodes = new ArrayList<>();
        if (combineRequest.getThirdIds() == null)
            inventoryCodes.add(combineRequest.getThirdId());
        else {
            inventoryCodes = combineRequest.getThirdIds();
        }
        if (inventoryCodes.size() > 0) {
            for (String inventoryCode : inventoryCodes) {
                UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
                udiRelevanceEntity1.setThirdId(inventoryCode);
                FilterErpGoodsRequest filterErpGoodsRequest = new FilterErpGoodsRequest();
                filterErpGoodsRequest.setCode(inventoryCode);
                filterErpGoodsRequest.setPage(1);
                filterErpGoodsRequest.setLimit(1);
                BaseResponse<PageSimpleResponse<ErpProductsResponse>> erpProducts = new ErpBasicClient().getErpProducts(filterErpGoodsRequest, url);
                List<ErpProductsResponse> erpProductsResponses = erpProducts.getData().getList();
                if (erpProductsResponses != null & erpProductsResponses.size() > 0) {
                    {
                        ErpProductsResponse erpProductsResponse = erpProductsResponses.get(0);
                        UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
                        BeanUtils.copyProperties(erpProductsResponse, udiInfoEntity);
                        udiInfoEntity.setNameCode(erpProductsResponse.getCode());
                        udiInfoEntity.setCpmctymc(erpProductsResponse.getName());
                        udiInfoEntity.setManufactory(erpProductsResponse.getManufactory());
                        udiInfoEntity.setYlqxzcrbarmc(erpProductsResponse.getManufactory());
                        udiInfoEntity.setGgxh(erpProductsResponse.getSpec());
                        udiInfoEntity.setZczbhhzbapzbh(erpProductsResponse.getRegisterNo());
                        udiInfoEntity.setUuid(CustomUtil.getUUId());
                        udiInfoEntity.setDiType(1);
                        udiInfoService.insertUdiInfo(udiInfoEntity);
                        udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());
                        udiRelevanceEntity1.setThirdName(erpProductsResponse.getName());
                        udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
                        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
                    }
                }
            }
        }
        return errMsg;
    }

    public String addLocalProduct(CombineRequest combineRequest) {
        String errMsg = null;
        List<String> inventoryCodes = new ArrayList<>();
        if (combineRequest.getThirdIds() == null)
            inventoryCodes.add(combineRequest.getThirdId());
        else {
            inventoryCodes = combineRequest.getThirdIds();
        }
        if (inventoryCodes.size() > 0) {
            for (String inventoryCode : inventoryCodes) {
                UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
                udiRelevanceEntity1.setThirdId(inventoryCode);
                FilterThrProductsRequest filterThrProductsRequest = new FilterThrProductsRequest();
                filterThrProductsRequest.setCode(inventoryCode);
                List<ThrProductsEntity> thrProductsEntities = thrProductsService.filterThrProductsRequest(filterThrProductsRequest);
                if (thrProductsEntities != null && thrProductsEntities.size() > 0) {
                    ThrProductsEntity thrProductsEntity = thrProductsEntities.get(0);
                    ErpProductsResponse erpProductsResponse = new ErpProductsResponse();
                    BeanUtils.copyProperties(thrProductsEntity, erpProductsResponse);
                    UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
                    BeanUtils.copyProperties(thrProductsEntity, udiInfoEntity);
                    udiInfoEntity.setNameCode(thrProductsEntity.getCode());
                    udiInfoEntity.setCpmctymc(thrProductsEntity.getName());
                    udiInfoEntity.setManufactory(thrProductsEntity.getManufactory());
                    udiInfoEntity.setYlqxzcrbarmc(thrProductsEntity.getManufactory());
                    udiInfoEntity.setGgxh(thrProductsEntity.getSpec());
                    udiInfoEntity.setZczbhhzbapzbh(thrProductsEntity.getRegisterNo());
                    udiInfoEntity.setUuid(CustomUtil.getUUId());
                    udiInfoEntity.setDiType(1);
                    udiInfoService.insertUdiInfo(udiInfoEntity);
                    udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());
                    udiRelevanceEntity1.setThirdName(thrProductsEntity.getName());
                    udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
                    udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
                }
            }
        }
        return errMsg;
    }

    //选入查询结果的所有DI
    @Async
    public void relAllUdi(FilterUdiInfoRequest productInfoFilterRequest) {
        int page = 1;
        int limit = 100;
        while (true) {
            productInfoFilterRequest.setPage(page);
            productInfoFilterRequest.setLimit(limit);
            List<UdiInfoEntity> udiInfoEntities = getUdiInfoEntity(productInfoFilterRequest);
            if (udiInfoEntities != null && udiInfoEntities.size() > 0) {
                udiInfoService.insertUdiInfos(udiInfoEntities);
                for (UdiInfoEntity udiInfoEntity : udiInfoEntities) {
                    UdiRelevanceEntity udiRelevanceEntity = new UdiRelevanceEntity();
                    udiRelevanceEntity.setUpdateTime(DateUtil.getDateTime());
                    udiRelevanceEntity.setUuid(udiInfoEntity.getUuid());
                    List<UdiRelevanceEntity> udiRelevanceEntities = udiRelevanceService.selectByUuid(udiInfoEntity.getUuid());
                    if (udiRelevanceEntities != null && udiRelevanceEntities.size() > 0) {
                        boolean isAdd = false;
                        for (UdiRelevanceEntity udiRelevanceEntity1 : udiRelevanceEntities) {
                            if (udiRelevanceEntity1.getThirdId() == null &&
                                    udiRelevanceEntity1.getThirdId2() == null && udiRelevanceEntity1.getThirdId1() == null &&
                                    udiRelevanceEntity1.getThirdId3() == null && udiRelevanceEntity1.getThirdId4() == null) {
                                //不能添加
                                isAdd = false;
                                break;
                            } else {
                                isAdd = true;
                            }
                        }
                        if (isAdd)
                            udiRelevanceService.insertUdiRelevance(udiRelevanceEntity);

                    } else {
                        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity);
                    }
                }
                if (udiInfoEntities.size() < limit) {
                    break;
                } else {
                    page++;
                }
            } else {
                break;
            }

        }


    }


    public List<UdiInfoEntity> getUdiInfoEntity(FilterUdiInfoRequest productInfoFilterRequest) {
        String nameCode = null;
        if (productInfoFilterRequest.getNameCode() != null) {
            UdiEntity udiEntity = FilterUdiUtils.getUdi(productInfoFilterRequest.getNameCode());
            if (udiEntity != null) {
                nameCode = udiEntity.getUdi();
            } else {
                nameCode = productInfoFilterRequest.getNameCode();
            }
        }
        Map<String, Object> paramMap = new HashMap<>(16);
        paramMap.put("page", productInfoFilterRequest.getPage());
        paramMap.put("limit", productInfoFilterRequest.getLimit());
        paramMap.put("ylqxzcrbarmc", productInfoFilterRequest.getYlqxzcrbarmc());
        paramMap.put("cpmctymc", productInfoFilterRequest.getCpmctymc());
        paramMap.put("nameCode", nameCode);
        paramMap.put("ggxh", productInfoFilterRequest.getGgxh());
        paramMap.put("zczbhhzbapzbh", productInfoFilterRequest.getZczbhhzbapzbh());
        paramMap.put("uuid", productInfoFilterRequest.getUuid());

        String response = HttpClient.mipsGet(udiUrl + "/udidl/device/filterUdi", paramMap);
        try {

            BaseResponse<PageSimpleResponse<UdiInfoEntity>> udiDlDeviceResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse<PageSimpleResponse<UdiInfoEntity>>>() {

                    });
            if (udiDlDeviceResponse != null) {
                List<UdiInfoEntity> udiInfoEntities = udiDlDeviceResponse.getData().getList();
                return udiInfoEntities;
            }
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        return null;
    }

}
