package com.glxp.sale.admin.thread;

import com.glxp.sale.admin.entity.info.CompanyProductRelevanceEntity;
import com.glxp.sale.admin.req.basic.FilterUdiInfoRequest;
import com.glxp.sale.admin.req.basic.UdiInfoExportRequest;
import com.glxp.sale.admin.res.basic.UdiRelevanceResponse;
import com.glxp.sale.admin.service.basic.UdiRelevanceService;
import com.glxp.sale.admin.service.info.CompanyProductRelevanceService;
import org.springframework.beans.BeanUtils;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

@Service
public class CompanyProductsRelService {
    @Resource
    private CompanyProductRelevanceService companyProductRelevanceService;
    @Resource
    UdiRelevanceService udiRelevanceService;

    @Async
    public void insertCompanyProducts(UdiInfoExportRequest udiInfoExportRequest) {
        //选中导出
        if (udiInfoExportRequest.getRlIds() != null && udiInfoExportRequest.getRlIds().size() > 0) {
            List<String> rlIdS = udiInfoExportRequest.getRlIds();
            for (String uuid : rlIdS) {
                CompanyProductRelevanceEntity companyProductRelevanceEntity = new CompanyProductRelevanceEntity();
                companyProductRelevanceEntity.setCreate_time(new Date());
                companyProductRelevanceEntity.setUpdate_time(new Date());
                companyProductRelevanceEntity.setAuditStatus("3");
                companyProductRelevanceEntity.setUdiRlIdFk(Integer.parseInt(uuid));
                companyProductRelevanceEntity.setCustomerId(udiInfoExportRequest.getCustomerId());
                boolean b = companyProductRelevanceService.insertCompanyProductRelevance(companyProductRelevanceEntity);
            }

        } else {//一键导出
            FilterUdiInfoRequest filterUdiInfoRequest = new FilterUdiInfoRequest();
            BeanUtils.copyProperties(udiInfoExportRequest, filterUdiInfoRequest);
            filterUdiInfoRequest.setPage(null);
            List<UdiRelevanceResponse> udiRelevanceResponses = udiRelevanceService.filterUdiRelevance(filterUdiInfoRequest);
            for (UdiRelevanceResponse udiRelevanceResponse : udiRelevanceResponses) {
                CompanyProductRelevanceEntity companyProductRelevanceEntity = new CompanyProductRelevanceEntity();
                companyProductRelevanceEntity.setCreate_time(new Date());
                companyProductRelevanceEntity.setUpdate_time(new Date());
                companyProductRelevanceEntity.setAuditStatus("3");
                companyProductRelevanceEntity.setUdiRlIdFk(udiRelevanceResponse.getId());
                companyProductRelevanceEntity.setProductUuid(udiRelevanceResponse.getUuid());
                companyProductRelevanceEntity.setCustomerId(udiInfoExportRequest.getCustomerId());
                boolean b = companyProductRelevanceService.insertCompanyProductRelevance(companyProductRelevanceEntity);
            }
        }
    }

}
