package com.glxp.sale.admin.thread;

import com.github.pagehelper.PageInfo;
import com.glxp.sale.admin.entity.basic.UdiInfoEntity;
import com.glxp.sale.admin.entity.inout.StockOrderDetailEntity;
import com.glxp.sale.admin.entity.inout.StockOrderEntity;
import com.glxp.sale.admin.entity.inout.StockQRCodeTextEntity;
import com.glxp.sale.admin.req.info.DeleteRequest;
import com.glxp.sale.admin.req.inout.*;
import com.glxp.sale.admin.res.PageSimpleResponse;
import com.glxp.sale.admin.service.basic.UdiInfoService;
import com.glxp.sale.admin.service.basic.UdiRelevanceService;
import com.glxp.sale.admin.service.inout.*;
import com.glxp.sale.admin.service.param.SystemParamConfigService;
import com.glxp.sale.common.res.BaseResponse;
import com.glxp.sale.common.util.ResultVOUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import javax.annotation.Resource;
import java.util.List;

@Service
public class StockOrderGenerateQRCodeService {

    private static final Logger logger = LoggerFactory.getLogger(StockOrderGenerateQRCodeService.class);
    @Resource
    private UdiRelevanceService udiRelevanceService;
    @Resource
    private UdiInfoService udiInfoService;
    @Resource
    private StockOrderService stockOrderService;
    @Resource
    private StockOrderDetailService stockOrderDetailService;
    @Resource
    private StockOrderDetailTempService stockOrderDetailTempService;
    @Resource
    private StockQRCodeTextService stockQRCodeTextService;

    @Autowired
    private SystemParamConfigService systemParamConfigService;

    @Async
    public void stockOrderDetailTempDealWith() {
        StockOrderQueryRequest stockOrderQueryRequest = new StockOrderQueryRequest();
        stockOrderQueryRequest.setLimit(100);
        stockOrderQueryRequest.setPage(1);
        List<StockOrderEntity> stockOrderEntityList = stockOrderService.listStockOrderNoDealWith(stockOrderQueryRequest);

        StockOrderDetailFilterRequest stockOrderDetailFilterRequest = new StockOrderDetailFilterRequest();
        stockOrderDetailFilterRequest.setLimit(100);
        stockOrderDetailFilterRequest.setPage(1);
        if (stockOrderEntityList.size() > 0) {
            for (StockOrderEntity stockOrderEntity : stockOrderEntityList) {
                stockOrderDetailFilterRequest.setOrderIdFk(stockOrderEntity.getId());
                List<StockOrderDetailEntity> stockOrderDetailEntityList =
                        stockOrderDetailTempService.filterStockOrderDetailTemp(stockOrderDetailFilterRequest);
                if (stockOrderDetailEntityList.size() < 1) {
                    stockOrderEntity.setStatus("401");
                    stockOrderService.updateById(stockOrderEntity);
                    continue;
                }

                for (StockOrderDetailEntity stockOrderDetailEntity : stockOrderDetailEntityList) {
                    UdiInfoEntity udiInfoEntity =
                            udiInfoService.findByNameCode(stockOrderDetailEntity.getProductId());
                    if (udiInfoEntity == null) {
                        stockOrderEntity.setStatus("401");//异常
                        stockOrderEntity.setStatusInfo("产品未找到");
                        stockOrderService.updateById(stockOrderEntity);
                        break;
                    }
                }
            }
        }
    }


    public void getStockOrderQRCodeText() {
        StockQRCodeTextFilterRequest stockQRCodeTextFilterRequest = new StockQRCodeTextFilterRequest();
        stockQRCodeTextFilterRequest.setLimit(100);
        stockQRCodeTextFilterRequest.setPage(1);
        stockQRCodeTextFilterRequest.setStatus(100 + "");//生成中
        List<StockQRCodeTextEntity> stockQRCodeTextEntityList =
                stockQRCodeTextService.filterStockQRCodeText(stockQRCodeTextFilterRequest);
        if (stockQRCodeTextEntityList.size() > 0) {
            for (StockQRCodeTextEntity stockQRCodeTextEntity : stockQRCodeTextEntityList) {

            }
        }
    }

    public void printQRCode(int id) {
        StockQRCodeTextEntity stockQRCodeTextEntity = stockQRCodeTextService.findOne(id + "");
        if (stockQRCodeTextEntity != null) {
            String text = stockQRCodeTextEntity.getText();
        }
    }
}
