package com.glxp.sale.admin.thread;

import com.glxp.sale.admin.constant.BasicProcessStatus;
import com.glxp.sale.admin.entity.thrsys.*;
import com.glxp.sale.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.sale.admin.req.thrsys.PostThrProductsRequest;
import com.glxp.sale.admin.res.basic.ErpProductsResponse;
import com.glxp.sale.admin.service.thrsys.*;
import com.glxp.sale.admin.util.CustomUtil;
import com.glxp.sale.common.enums.ResultEnum;
import com.glxp.sale.common.util.ResultVOUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class ThrProductsImportService {

    @Resource
    private ThrProductsDlService thrProductsDlService;
    @Resource
    ThrProductsImportLogService thrProductsImportLogService;

    @Async
    public void importThrProduct(PostThrProductsRequest postThrProductsRequest) {

        List<ErpProductsResponse> erpProductsResponses = postThrProductsRequest.getDatas();

        String genKey = postThrProductsRequest.getGenKey();
        if (genKey == null) {
            genKey = CustomUtil.getId();
        }
        ThrProductsImportLogEntity thrProductsImportLogEntity = thrProductsImportLogService.selectByGenKey(genKey);
        if (thrProductsImportLogEntity == null) {
            thrProductsImportLogEntity = new ThrProductsImportLogEntity();
            thrProductsImportLogEntity.setGenKey(genKey);
            if (postThrProductsRequest.getUploadType() != null) {
                thrProductsImportLogEntity.setFromType(postThrProductsRequest.getUploadType());
            } else
                thrProductsImportLogEntity.setFromType("文件导入");
            thrProductsImportLogEntity.setStatus(BasicProcessStatus.UDIINFO_IMPORT_PROCESS);
            thrProductsImportLogEntity.setUpdateTime(new Date());
            thrProductsImportLogEntity.setThirdSysFk(postThrProductsRequest.getThirdSys());
            thrProductsImportLogService.insertImportLog(thrProductsImportLogEntity);
        }

        if (erpProductsResponses != null && erpProductsResponses.size() > 0) {
            thrProductsDlService.insertData(genKey, erpProductsResponses, postThrProductsRequest.getThirdSys());
        } else {
            thrProductsImportLogEntity.setStatus(BasicProcessStatus.UDIINFO_IMPORT_FAIL);
            thrProductsImportLogEntity.setUpdateTime(new Date());
            thrProductsImportLogEntity.setRemark("导入数据为空");
            thrProductsImportLogService.updateImportLog(thrProductsImportLogEntity);
        }
    }
}
